diff --git a/libpurple/purplecredentialmanager.h b/libpurple/purplecredentialmanager.h
--- a/libpurple/purplecredentialmanager.h
+++ b/libpurple/purplecredentialmanager.h
@@ -28,6 +28,7 @@
 
 #include "purpleaccount.h"
 #include "purplecredentialprovider.h"
+#include "purpleversion.h"
 
 G_BEGIN_DECLS
 
@@ -38,9 +39,13 @@ G_BEGIN_DECLS
  *
  * Since: 3.0.0
  */
-#define PURPLE_CREDENTIAL_MANAGER_DOMAIN (g_quark_from_static_string("purple-credential-manager"))
+#define PURPLE_CREDENTIAL_MANAGER_DOMAIN \
+	g_quark_from_static_string("purple-credential-manager") \
+	PURPLE_AVAILABLE_MACRO_IN_3_0
 
 #define PURPLE_TYPE_CREDENTIAL_MANAGER (purple_credential_manager_get_type())
+
+PURPLE_AVAILABLE_IN_3_0
 G_DECLARE_FINAL_TYPE(PurpleCredentialManager, purple_credential_manager,
                      PURPLE, CREDENTIAL_MANAGER, GObject)
 
@@ -66,6 +71,7 @@ G_DECLARE_FINAL_TYPE(PurpleCredentialMan
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_TYPE_IN_3_0
 typedef void (*PurpleCredentialManagerForeachFunc)(PurpleCredentialProvider *provider, gpointer data);
 
 /**
@@ -77,6 +83,7 @@ typedef void (*PurpleCredentialManagerFo
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleCredentialManager *purple_credential_manager_get_default(void);
 
 /**
@@ -92,6 +99,7 @@ PurpleCredentialManager *purple_credenti
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_credential_manager_register(PurpleCredentialManager *manager, PurpleCredentialProvider *provider, GError **error);
 
 /**
@@ -107,6 +115,7 @@ gboolean purple_credential_manager_regis
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_credential_manager_unregister(PurpleCredentialManager *manager, PurpleCredentialProvider *provider, GError **error);
 
 /**
@@ -128,6 +137,7 @@ gboolean purple_credential_manager_unreg
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_credential_manager_set_active(PurpleCredentialManager *manager, const gchar *id, GError **error);
 
 /**
@@ -141,6 +151,7 @@ gboolean purple_credential_manager_set_a
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleCredentialProvider *purple_credential_manager_get_active(PurpleCredentialManager *manager);
 
 /**
@@ -157,6 +168,7 @@ PurpleCredentialProvider *purple_credent
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_credential_manager_read_password_async(PurpleCredentialManager *manager, PurpleAccount *account, GCancellable *cancellable, GAsyncReadyCallback callback, gpointer data);
 
 /**
@@ -173,6 +185,7 @@ void purple_credential_manager_read_pass
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gchar *purple_credential_manager_read_password_finish(PurpleCredentialManager *manager, GAsyncResult *result, GError **error);
 
 /**
@@ -190,6 +203,7 @@ gchar *purple_credential_manager_read_pa
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_credential_manager_write_password_async(PurpleCredentialManager *manager, PurpleAccount *account, const gchar *password, GCancellable *cancellable, GAsyncReadyCallback callback, gpointer data);
 
 /**
@@ -206,6 +220,7 @@ void purple_credential_manager_write_pas
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_credential_manager_write_password_finish(PurpleCredentialManager *manager, GAsyncResult *result, GError **error);
 
 /**
@@ -222,6 +237,7 @@ gboolean purple_credential_manager_write
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_credential_manager_clear_password_async(PurpleCredentialManager *manager, PurpleAccount *account, GCancellable *cancellable, GAsyncReadyCallback callback, gpointer data);
 
 /**
@@ -239,6 +255,7 @@ void purple_credential_manager_clear_pas
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_credential_manager_clear_password_finish(PurpleCredentialManager *manager, GAsyncResult *result, GError **error);
 
 /**
@@ -251,6 +268,7 @@ gboolean purple_credential_manager_clear
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_credential_manager_foreach(PurpleCredentialManager *manager, PurpleCredentialManagerForeachFunc func, gpointer data);
 
 G_END_DECLS
diff --git a/libpurple/purplecredentialprovider.h b/libpurple/purplecredentialprovider.h
--- a/libpurple/purplecredentialprovider.h
+++ b/libpurple/purplecredentialprovider.h
@@ -27,6 +27,7 @@
 #include <glib-object.h>
 
 #include "purpleaccount.h"
+#include "purpleversion.h"
 #include "request.h"
 
 G_BEGIN_DECLS
@@ -38,7 +39,9 @@ G_BEGIN_DECLS
  *
  * Since: 3.0.0
  */
-#define PURPLE_CREDENTIAL_PROVIDER_DOMAIN (g_quark_from_static_string("purple-credential-provider"))
+#define PURPLE_CREDENTIAL_PROVIDER_DOMAIN \
+	g_quark_from_static_string("purple-credential-provider") \
+	PURPLE_AVAILABLE_MACRO_IN_3_0
 
 /**
  * PurpleCredentialProvider:
@@ -52,6 +55,8 @@ G_BEGIN_DECLS
  */
 
 #define PURPLE_TYPE_CREDENTIAL_PROVIDER (purple_credential_provider_get_type())
+
+PURPLE_AVAILABLE_IN_3_0
 G_DECLARE_DERIVABLE_TYPE(PurpleCredentialProvider, purple_credential_provider,
                          PURPLE, CREDENTIAL_PROVIDER, GObject)
 
@@ -104,6 +109,7 @@ struct _PurpleCredentialProviderClass {
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const gchar *purple_credential_provider_get_id(PurpleCredentialProvider *provider);
 
 /**
@@ -116,6 +122,7 @@ const gchar *purple_credential_provider_
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const gchar *purple_credential_provider_get_name(PurpleCredentialProvider *provider);
 
 /**
@@ -129,6 +136,7 @@ const gchar *purple_credential_provider_
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const gchar *purple_credential_provider_get_description(PurpleCredentialProvider *provider);
 
 /**
@@ -144,6 +152,7 @@ const gchar *purple_credential_provider_
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_credential_provider_is_valid(PurpleCredentialProvider *provider, GError **error);
 
 /**
@@ -159,6 +168,7 @@ gboolean purple_credential_provider_is_v
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_credential_provider_read_password_async(PurpleCredentialProvider *provider, PurpleAccount *account, GCancellable *cancellable, GAsyncReadyCallback callback, gpointer data);
 
 /**
@@ -175,6 +185,7 @@ void purple_credential_provider_read_pas
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gchar *purple_credential_provider_read_password_finish(PurpleCredentialProvider *provider, GAsyncResult *result, GError **error);
 
 /**
@@ -191,6 +202,7 @@ gchar *purple_credential_provider_read_p
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_credential_provider_write_password_async(PurpleCredentialProvider *provider, PurpleAccount *account, const gchar *password, GCancellable *cancellable, GAsyncReadyCallback callback, gpointer data);
 
 /**
@@ -208,6 +220,7 @@ void purple_credential_provider_write_pa
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_credential_provider_write_password_finish(PurpleCredentialProvider *provider, GAsyncResult *result, GError **error);
 
 /**
@@ -223,6 +236,7 @@ gboolean purple_credential_provider_writ
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_credential_provider_clear_password_async(PurpleCredentialProvider *provider, PurpleAccount *account, GCancellable *cancellable, GAsyncReadyCallback callback, gpointer data);
 
 /**
@@ -240,6 +254,7 @@ void purple_credential_provider_clear_pa
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_credential_provider_clear_password_finish(PurpleCredentialProvider *provider, GAsyncResult *result, GError **error);
 
 /**
@@ -253,6 +268,7 @@ gboolean purple_credential_provider_clea
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GSettings *purple_credential_provider_get_settings(PurpleCredentialProvider *provider);
 
 G_END_DECLS
diff --git a/libpurple/purpledebugui.h b/libpurple/purpledebugui.h
--- a/libpurple/purpledebugui.h
+++ b/libpurple/purpledebugui.h
@@ -30,6 +30,8 @@
 #include <glib.h>
 #include <glib-object.h>
 
+#include "purpleversion.h"
+
 G_BEGIN_DECLS
 
 #define PURPLE_TYPE_DEBUG_UI (purple_debug_ui_get_type())
@@ -42,6 +44,7 @@ G_BEGIN_DECLS
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 G_DECLARE_INTERFACE(PurpleDebugUi, purple_debug_ui, PURPLE, DEBUG_UI, GObject)
 
 #include "debug.h"
@@ -82,6 +85,7 @@ struct _PurpleDebugUiInterface {
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_debug_ui_is_enabled(PurpleDebugUi *ui, PurpleDebugLevel level, const gchar *category);
 
 /**
@@ -95,6 +99,7 @@ gboolean purple_debug_ui_is_enabled(Purp
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_debug_ui_print(PurpleDebugUi *ui, PurpleDebugLevel level, const gchar *category, const gchar *arg_s);
 
 G_END_DECLS
diff --git a/libpurple/purplefiletransfer.h b/libpurple/purplefiletransfer.h
--- a/libpurple/purplefiletransfer.h
+++ b/libpurple/purplefiletransfer.h
@@ -30,6 +30,7 @@
 #include <glib-object.h>
 
 #include "purpleaccount.h"
+#include "purpleversion.h"
 
 G_BEGIN_DECLS
 
@@ -64,6 +65,8 @@ typedef enum {
  */
 
 #define PURPLE_TYPE_FILE_TRANSFER purple_file_transfer_get_type()
+
+PURPLE_AVAILABLE_IN_3_0
 G_DECLARE_FINAL_TYPE(PurpleFileTransfer, purple_file_transfer, PURPLE,
                      FILE_TRANSFER, GObject)
 
@@ -84,6 +87,7 @@ G_DECLARE_FINAL_TYPE(PurpleFileTransfer,
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleFileTransfer *purple_file_transfer_new_send(PurpleAccount *account, PurpleContactInfo *remote, GFile *local_file);
 
 /**
@@ -103,6 +107,7 @@ PurpleFileTransfer *purple_file_transfer
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleFileTransfer *purple_file_transfer_new_receive(PurpleAccount *account, PurpleContactInfo *remote, const char *filename, guint64 file_size);
 
 /**
@@ -115,6 +120,7 @@ PurpleFileTransfer *purple_file_transfer
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleAccount *purple_file_transfer_get_account(PurpleFileTransfer *transfer);
 
 /**
@@ -128,6 +134,7 @@ PurpleAccount *purple_file_transfer_get_
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleContactInfo *purple_file_transfer_get_remote(PurpleFileTransfer *transfer);
 
 /**
@@ -140,6 +147,7 @@ PurpleContactInfo *purple_file_transfer_
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleContactInfo *purple_file_transfer_get_initiator(PurpleFileTransfer *transfer);
 
 /**
@@ -153,6 +161,7 @@ PurpleContactInfo *purple_file_transfer_
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GCancellable *purple_file_transfer_get_cancellable(PurpleFileTransfer *transfer);
 
 /**
@@ -165,6 +174,7 @@ GCancellable *purple_file_transfer_get_c
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleFileTransferState purple_file_transfer_get_state(PurpleFileTransfer *transfer);
 
 /**
@@ -179,6 +189,7 @@ PurpleFileTransferState purple_file_tran
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_file_transfer_set_state(PurpleFileTransfer *transfer, PurpleFileTransferState state);
 
 /**
@@ -191,6 +202,7 @@ void purple_file_transfer_set_state(Purp
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GError *purple_file_transfer_get_error(PurpleFileTransfer *transfer);
 
 /**
@@ -202,6 +214,7 @@ GError *purple_file_transfer_get_error(P
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_file_transfer_set_error(PurpleFileTransfer *transfer, GError *error);
 
 /**
@@ -214,6 +227,7 @@ void purple_file_transfer_set_error(Purp
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GFile *purple_file_transfer_get_local_file(PurpleFileTransfer *transfer);
 
 /**
@@ -225,6 +239,7 @@ GFile *purple_file_transfer_get_local_fi
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_file_transfer_set_local_file(PurpleFileTransfer *transfer, GFile *local_file);
 
 /**
@@ -237,6 +252,7 @@ void purple_file_transfer_set_local_file
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const char *purple_file_transfer_get_filename(PurpleFileTransfer *transfer);
 
 /**
@@ -249,6 +265,7 @@ const char *purple_file_transfer_get_fil
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 guint64 purple_file_transfer_get_file_size(PurpleFileTransfer *transfer);
 
 /**
@@ -261,6 +278,7 @@ guint64 purple_file_transfer_get_file_si
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const char *purple_file_transfer_get_content_type(PurpleFileTransfer *transfer);
 
 /**
@@ -272,6 +290,7 @@ const char *purple_file_transfer_get_con
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_file_transfer_set_content_type(PurpleFileTransfer *transfer, const char *content_type);
 
 /**
@@ -285,6 +304,7 @@ void purple_file_transfer_set_content_ty
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const char *purple_file_transfer_get_message(PurpleFileTransfer *transfer);
 
 /**
@@ -296,6 +316,7 @@ const char *purple_file_transfer_get_mes
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_file_transfer_set_message(PurpleFileTransfer *transfer, const char *message);
 
 G_END_DECLS
diff --git a/libpurple/purplehistoryadapter.h b/libpurple/purplehistoryadapter.h
--- a/libpurple/purplehistoryadapter.h
+++ b/libpurple/purplehistoryadapter.h
@@ -28,6 +28,7 @@
 
 #include "purplemessage.h"
 #include "purpleconversation.h"
+#include "purpleversion.h"
 
 G_BEGIN_DECLS
 
@@ -38,7 +39,9 @@ G_BEGIN_DECLS
  *
  * Since: 3.0.0
  */
-#define PURPLE_HISTORY_ADAPTER_DOMAIN (g_quark_from_static_string("purple-history-adapter"))
+#define PURPLE_HISTORY_ADAPTER_DOMAIN \
+	g_quark_from_static_string("purple-history-adapter") \
+	PURPLE_AVAILABLE_MACRO_IN_3_0
 
 /**
  * PurpleHistoryAdapter:
@@ -51,6 +54,8 @@ G_BEGIN_DECLS
  */
 
 #define PURPLE_TYPE_HISTORY_ADAPTER (purple_history_adapter_get_type())
+
+PURPLE_AVAILABLE_IN_3_0
 G_DECLARE_DERIVABLE_TYPE(PurpleHistoryAdapter, purple_history_adapter,
                          PURPLE, HISTORY_ADAPTER, GObject)
 
@@ -89,6 +94,7 @@ struct _PurpleHistoryAdapterClass {
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const gchar *purple_history_adapter_get_id(PurpleHistoryAdapter *adapter);
 
 /**
@@ -101,6 +107,7 @@ const gchar *purple_history_adapter_get_
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const gchar *purple_history_adapter_get_name(PurpleHistoryAdapter *adapter);
 
 /**
@@ -116,6 +123,7 @@ const gchar *purple_history_adapter_get_
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_history_adapter_write(PurpleHistoryAdapter *adapter,
                                       PurpleConversation *conversation,
                                       PurpleMessage *message,
@@ -133,6 +141,7 @@ gboolean purple_history_adapter_write(Pu
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GList *purple_history_adapter_query(PurpleHistoryAdapter *adapter,
                                     const gchar *query,
                                     GError **error);
@@ -149,6 +158,7 @@ GList *purple_history_adapter_query(Purp
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_history_adapter_remove(PurpleHistoryAdapter *adapter,
                                        const gchar *query,
                                        GError **error);
diff --git a/libpurple/purplehistorymanager.h b/libpurple/purplehistorymanager.h
--- a/libpurple/purplehistorymanager.h
+++ b/libpurple/purplehistorymanager.h
@@ -27,6 +27,7 @@
 #include <glib-object.h>
 
 #include "purplehistoryadapter.h"
+#include "purpleversion.h"
 
 G_BEGIN_DECLS
 
@@ -37,9 +38,13 @@ G_BEGIN_DECLS
  *
  * Since: 3.0.0
  */
-#define PURPLE_HISTORY_MANAGER_DOMAIN (g_quark_from_static_string("purple-history-manager"))
+#define PURPLE_HISTORY_MANAGER_DOMAIN \
+	g_quark_from_static_string("purple-history-manager") \
+	PURPLE_AVAILABLE_MACRO_IN_3_0
 
 #define PURPLE_TYPE_HISTORY_MANAGER (purple_history_manager_get_type())
+
+PURPLE_AVAILABLE_IN_3_0
 G_DECLARE_FINAL_TYPE(PurpleHistoryManager, purple_history_manager, PURPLE,
                      HISTORY_MANAGER, GObject)
 
@@ -62,6 +67,7 @@ G_DECLARE_FINAL_TYPE(PurpleHistoryManage
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_TYPE_IN_3_0
 typedef void (*PurpleHistoryManagerForeachFunc)(PurpleHistoryAdapter *adapter, gpointer data);
 
 /**
@@ -73,6 +79,7 @@ typedef void (*PurpleHistoryManagerForea
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleHistoryManager *purple_history_manager_get_default(void);
 
 /**
@@ -85,6 +92,7 @@ PurpleHistoryManager *purple_history_man
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
  PurpleHistoryAdapter *purple_history_manager_get_active(PurpleHistoryManager *manager);
 
  /**
@@ -100,6 +108,7 @@ PurpleHistoryManager *purple_history_man
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_history_manager_set_active(PurpleHistoryManager *manager, const gchar *id, GError **error);
 
 /**
@@ -115,6 +124,7 @@ gboolean purple_history_manager_set_acti
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_history_manager_register(PurpleHistoryManager *manager, PurpleHistoryAdapter *adapter, GError **error);
 
 /**
@@ -130,6 +140,7 @@ gboolean purple_history_manager_register
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_history_manager_unregister(PurpleHistoryManager *manager, PurpleHistoryAdapter *adapter, GError **error);
 
 /**
@@ -143,6 +154,7 @@ gboolean purple_history_manager_unregist
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleHistoryAdapter *purple_history_manager_find(PurpleHistoryManager *manager, const gchar *id);
 
 /**
@@ -157,6 +169,7 @@ PurpleHistoryAdapter *purple_history_man
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GList *purple_history_manager_get_all(PurpleHistoryManager *manager);
 
 /**
@@ -173,6 +186,7 @@ GList *purple_history_manager_get_all(Pu
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GList *purple_history_manager_query(PurpleHistoryManager *manager, const gchar *query, GError **error);
 
 /**
@@ -188,6 +202,7 @@ GList *purple_history_manager_query(Purp
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_history_manager_remove(PurpleHistoryManager *manager, const gchar *query, GError **error);
 
 /**
@@ -203,6 +218,7 @@ gboolean purple_history_manager_remove(P
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_history_manager_write(PurpleHistoryManager *manager, PurpleConversation *conversation, PurpleMessage *message, GError **error);
 
 /**
@@ -215,6 +231,7 @@ gboolean purple_history_manager_write(Pu
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_history_manager_foreach(PurpleHistoryManager *manager, PurpleHistoryManagerForeachFunc func, gpointer data);
 
 G_END_DECLS
diff --git a/libpurple/purpleidlemanager.h b/libpurple/purpleidlemanager.h
--- a/libpurple/purpleidlemanager.h
+++ b/libpurple/purpleidlemanager.h
@@ -30,7 +30,11 @@
 #include <glib.h>
 #include <glib-object.h>
 
+#include "purpleversion.h"
+
 #define PURPLE_TYPE_IDLE_MANAGER (purple_idle_manager_get_type())
+
+PURPLE_AVAILABLE_IN_3_0
 G_DECLARE_FINAL_TYPE(PurpleIdleManager, purple_idle_manager, PURPLE,
                      IDLE_MANAGER, GObject)
 
@@ -86,6 +90,7 @@ G_BEGIN_DECLS
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleIdleManager *purple_idle_manager_get_default(void);
 
 /**
@@ -102,6 +107,7 @@ PurpleIdleManager *purple_idle_manager_g
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_idle_manager_set_source(PurpleIdleManager *manager, const char *source, GDateTime *timestamp);
 
 /**
@@ -115,6 +121,7 @@ gboolean purple_idle_manager_set_source(
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GDateTime *purple_idle_manager_get_timestamp(PurpleIdleManager *manager);
 
 G_END_DECLS
diff --git a/libpurple/purpleidleui.h b/libpurple/purpleidleui.h
--- a/libpurple/purpleidleui.h
+++ b/libpurple/purpleidleui.h
@@ -28,9 +28,13 @@
 
 #include <time.h>
 
+#include "purpleversion.h"
+
 G_BEGIN_DECLS
 
 #define PURPLE_TYPE_IDLE_UI (purple_idle_ui_get_type())
+
+PURPLE_AVAILABLE_IN_3_0
 G_DECLARE_INTERFACE(PurpleIdleUi, purple_idle_ui, PURPLE, IDLE_UI, GObject)
 
 /**
@@ -63,6 +67,7 @@ struct _PurpleIdleUiInterface {
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 time_t purple_idle_ui_get_idle_time(PurpleIdleUi *ui);
 
 G_END_DECLS
diff --git a/libpurple/purplekeyvaluepair.h b/libpurple/purplekeyvaluepair.h
--- a/libpurple/purplekeyvaluepair.h
+++ b/libpurple/purplekeyvaluepair.h
@@ -30,6 +30,8 @@
 #include <glib.h>
 #include <glib-object.h>
 
+#include "purpleversion.h"
+
 #define PURPLE_TYPE_KEY_VALUE_PAIR (purple_key_value_pair_get_type())
 
 /**
@@ -75,6 +77,7 @@ GType purple_key_value_pair_get_type(voi
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleKeyValuePair *purple_key_value_pair_new(const gchar *key, gpointer value);
 
 /**
@@ -90,6 +93,7 @@ PurpleKeyValuePair *purple_key_value_pai
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleKeyValuePair *purple_key_value_pair_new_full(const gchar *key, gpointer value, GDestroyNotify value_destroy_func);
 
 /**
@@ -100,6 +104,7 @@ PurpleKeyValuePair *purple_key_value_pai
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_key_value_pair_free(PurpleKeyValuePair *kvp);
 
 /**
diff --git a/libpurple/purplemenu.h b/libpurple/purplemenu.h
--- a/libpurple/purplemenu.h
+++ b/libpurple/purplemenu.h
@@ -30,6 +30,8 @@
 #include <glib.h>
 #include <gio/gio.h>
 
+#include "purpleversion.h"
+
 G_BEGIN_DECLS
 
 #define PURPLE_MENU_ATTRIBUTE_DYNAMIC_TARGET "dynamic-target"
@@ -47,6 +49,7 @@ G_BEGIN_DECLS
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_TYPE_IN_3_0
 typedef void (*PurpleMenuWalkFunc)(GMenuModel *model, gint index, gpointer data);
 
 /**
@@ -59,6 +62,7 @@ typedef void (*PurpleMenuWalkFunc)(GMenu
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_menu_walk(GMenuModel *model, PurpleMenuWalkFunc func, gpointer data);
 
 /**
@@ -82,6 +86,7 @@ void purple_menu_walk(GMenuModel *model,
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_menu_populate_dynamic_targets(GMenu *menu, const gchar *first_property, ...) G_GNUC_NULL_TERMINATED;
 
 /**
@@ -103,6 +108,7 @@ void purple_menu_populate_dynamic_target
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_menu_populate_dynamic_targetsv(GMenu *menu, GHashTable *properties);
 
 /**
@@ -116,6 +122,7 @@ void purple_menu_populate_dynamic_target
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GMenu *purple_menu_copy(GMenuModel *model);
 
 G_END_DECLS
diff --git a/libpurple/purplemessage.h b/libpurple/purplemessage.h
--- a/libpurple/purplemessage.h
+++ b/libpurple/purplemessage.h
@@ -30,6 +30,7 @@
 #include <glib-object.h>
 
 #include "purpleattachment.h"
+#include "purpleversion.h"
 
 G_BEGIN_DECLS
 
@@ -92,6 +93,7 @@ typedef enum /*< flags >*/
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_TYPE_IN_3_0
 typedef enum /*< prefix=PURPLE_MESSAGE_CONTENT_TYPE,underscore_name=PURPLE_MESSAGE_CONTENT_TYPE >*/
 {
 	PURPLE_MESSAGE_CONTENT_TYPE_PLAIN = 0,
@@ -124,6 +126,7 @@ G_DECLARE_FINAL_TYPE(PurpleMessage, purp
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleMessage *purple_message_new_outgoing(const gchar *author, const gchar *recipient, const gchar *contents, PurpleMessageFlags flags);
 
 /**
@@ -141,6 +144,7 @@ PurpleMessage *purple_message_new_outgoi
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleMessage *purple_message_new_incoming(const gchar *who, const gchar *contents, PurpleMessageFlags flags, guint64 timestamp);
 
 /**
@@ -156,6 +160,7 @@ PurpleMessage *purple_message_new_incomi
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleMessage *purple_message_new_system(const gchar *contents, PurpleMessageFlags flags);
 
 /**
@@ -169,6 +174,7 @@ PurpleMessage *purple_message_new_system
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const gchar *purple_message_get_id(PurpleMessage *message);
 
 /**
@@ -183,6 +189,7 @@ const gchar *purple_message_get_id(Purpl
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_message_set_id(PurpleMessage *message, const char *id);
 
 /**
@@ -195,6 +202,7 @@ void purple_message_set_id(PurpleMessage
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const gchar *purple_message_get_author(PurpleMessage *message);
 
 /**
@@ -209,6 +217,7 @@ const gchar *purple_message_get_author(P
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_message_set_author_name_color(PurpleMessage *message, const gchar *color);
 
 /**
@@ -221,6 +230,7 @@ void purple_message_set_author_name_colo
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const gchar *purple_message_get_author_name_color(PurpleMessage *message);
 
 /**
@@ -232,6 +242,7 @@ const gchar *purple_message_get_author_n
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_message_set_recipient(PurpleMessage *message, const gchar *recipient);
 
 /**
@@ -244,6 +255,7 @@ void purple_message_set_recipient(Purple
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const gchar *purple_message_get_recipient(PurpleMessage *message);
 
 /**
@@ -255,6 +267,7 @@ const gchar *purple_message_get_recipien
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_message_set_author_alias(PurpleMessage *message, const gchar *alias);
 
 /**
@@ -267,6 +280,7 @@ void purple_message_set_author_alias(Pur
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const gchar *purple_message_get_author_alias(PurpleMessage *message);
 
 /**
@@ -278,6 +292,7 @@ const gchar *purple_message_get_author_a
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_message_set_contents(PurpleMessage *message, const gchar *cont);
 
 /**
@@ -290,6 +305,7 @@ void purple_message_set_contents(PurpleM
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const gchar *purple_message_get_contents(PurpleMessage *message);
 
 /**
@@ -301,6 +317,7 @@ const gchar *purple_message_get_contents
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_message_set_content_type(PurpleMessage *message, PurpleMessageContentType content_type);
 
 /**
@@ -313,6 +330,7 @@ void purple_message_set_content_type(Pur
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleMessageContentType purple_message_get_content_type(PurpleMessage *message);
 
 /**
@@ -325,6 +343,7 @@ PurpleMessageContentType purple_message_
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_message_is_empty(PurpleMessage *message);
 
 /**
@@ -336,6 +355,7 @@ gboolean purple_message_is_empty(PurpleM
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_message_set_timestamp(PurpleMessage *message, GDateTime *timestamp);
 
 /**
@@ -349,6 +369,7 @@ void purple_message_set_timestamp(Purple
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GDateTime *purple_message_get_timestamp(PurpleMessage *message);
 
 /**
@@ -372,6 +393,7 @@ gchar *purple_message_format_timestamp(P
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_message_set_flags(PurpleMessage *message, PurpleMessageFlags flags);
 
 /**
@@ -384,6 +406,7 @@ void purple_message_set_flags(PurpleMess
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleMessageFlags purple_message_get_flags(PurpleMessage *message);
 
 /**
@@ -396,6 +419,7 @@ PurpleMessageFlags purple_message_get_fl
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_message_set_error(PurpleMessage *message, GError *error);
 
 /**
@@ -408,6 +432,7 @@ void purple_message_set_error(PurpleMess
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GError *purple_message_get_error(PurpleMessage *message);
 
 /**
@@ -421,6 +446,7 @@ GError *purple_message_get_error(PurpleM
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_message_add_attachment(PurpleMessage *message, PurpleAttachment *attachment);
 
 /**
@@ -435,6 +461,7 @@ gboolean purple_message_add_attachment(P
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_message_remove_attachment(PurpleMessage *message, guint64 id);
 
 /**
@@ -449,6 +476,7 @@ gboolean purple_message_remove_attachmen
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleAttachment *purple_message_get_attachment(PurpleMessage *message, guint64 id);
 
 /**
@@ -461,6 +489,7 @@ PurpleAttachment *purple_message_get_att
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_message_foreach_attachment(PurpleMessage *message, PurpleAttachmentForeachFunc func, gpointer data);
 
 /**
@@ -471,6 +500,7 @@ void purple_message_foreach_attachment(P
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_message_clear_attachments(PurpleMessage *message);
 
 /**
@@ -485,6 +515,7 @@ void purple_message_clear_attachments(Pu
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_message_get_action(PurpleMessage *message);
 
 /**
@@ -498,6 +529,7 @@ gboolean purple_message_get_action(Purpl
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_message_set_action(PurpleMessage *message, gboolean action);
 
 /**
@@ -517,6 +549,7 @@ void purple_message_set_action(PurpleMes
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_message_get_delivered(PurpleMessage *message);
 
 /**
@@ -532,6 +565,7 @@ gboolean purple_message_get_delivered(Pu
  *
  * Since: 3.0.0.
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_message_set_delivered(PurpleMessage *message, gboolean delivered);
 
 /**
@@ -545,6 +579,7 @@ void purple_message_set_delivered(Purple
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GDateTime *purple_message_get_delivered_at(PurpleMessage *message);
 
 /**
@@ -559,6 +594,7 @@ GDateTime *purple_message_get_delivered_
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_message_set_delivered_at(PurpleMessage *message, GDateTime *datetime);
 
 /**
@@ -571,6 +607,7 @@ void purple_message_set_delivered_at(Pur
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_message_get_edited(PurpleMessage *message);
 
 /**
@@ -586,6 +623,7 @@ gboolean purple_message_get_edited(Purpl
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_message_set_edited(PurpleMessage *message, gboolean edited);
 
 /**
@@ -599,6 +637,7 @@ void purple_message_set_edited(PurpleMes
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GDateTime *purple_message_get_edited_at(PurpleMessage *message);
 
 /**
@@ -613,6 +652,7 @@ GDateTime *purple_message_get_edited_at(
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_message_set_edited_at(PurpleMessage *message, GDateTime *datetime);
 
 G_END_DECLS
diff --git a/libpurple/purplenoopcredentialprovider.h b/libpurple/purplenoopcredentialprovider.h
--- a/libpurple/purplenoopcredentialprovider.h
+++ b/libpurple/purplenoopcredentialprovider.h
@@ -27,6 +27,7 @@
 #include <glib-object.h>
 
 #include "purplecredentialprovider.h"
+#include "purpleversion.h"
 
 G_BEGIN_DECLS
 
@@ -41,6 +42,8 @@ G_BEGIN_DECLS
  */
 
 #define PURPLE_TYPE_NOOP_CREDENTIAL_PROVIDER (purple_noop_credential_provider_get_type())
+
+PURPLE_AVAILABLE_IN_3_0
 G_DECLARE_FINAL_TYPE(PurpleNoopCredentialProvider,
                      purple_noop_credential_provider,
                      PURPLE, NOOP_CREDENTIAL_PROVIDER, PurpleCredentialProvider)
